# If building for a new kernel, please update and commit the new version where you see "KERNEL UPDATE"
# Commits for a new kernel should be tagged in Git with the exact version of that kernel.  For ease of finding things.

# If building for a new Intel driver version, please update the version where you see "DRIVER UPDATE"
# Also, driver updates will require a new ice-<version>.tar.gz source tarball from upstream to be placed in our lookaside storage (referenced by .kmod-ciq-ice.metadata)


%define kmod_name		ice
%define kmod_vendor		CIQ
%define kmod_rpm_name		kmod-ciq-ice

# DRIVER UPDATE:  Set version here if updating the actual Intel ICE driver from upstream
%define kmod_driver_version	1.9.11

%define kmod_driver_epoch	%{nil}
%define kmod_rpm_release	1

# KERNEL UPDATE:  Need to set kernel version to the one we want to build against
%define kmod_kernel_version	 4.18.0-372.16.1.el8_6.0.1

%define kmod_kernel_version_min	%{nil}
%define kmod_kernel_version_dep	%{nil}
%define kmod_kbuild_dir		drivers/net/ethernet/intel/ice
%define kmod_dependencies       %{nil}
%define kmod_dist_build_deps	%{nil}
%define kmod_build_dependencies	%{nil}
%define kmod_devel_package	0
%define kmod_devel_src_paths	%{nil}
%define kmod_install_path	extra/kmod-ciq-ice
%define kernel_pkg		kernel
%define kernel_devel_pkg	kernel-devel
%define kernel_modules_pkg	kernel-modules



%{!?dist: %define dist .el8}
%{!?make_build: %define make_build make}

%if "%{kmod_kernel_version_dep}" == ""
%define kmod_kernel_version_dep %{kmod_kernel_version}
%endif

%if "%{kmod_dist_build_deps}" == ""
%if (0%{?rhel} > 7) || (0%{?centos} > 7)
%define kmod_dist_build_deps redhat-rpm-config kernel-abi-whitelists elfutils-libelf-devel kernel-rpm-macros kmod
%else
%define kmod_dist_build_deps redhat-rpm-config kernel-abi-whitelists
%endif
%endif

Source0:	%{kmod_name}-%{kmod_driver_version}.tar.gz
Source1:  kmod-ciq-ice.conf

# Source code patches against driver:



%define findpat %( echo "%""P" )
%define __find_requires /usr/lib/rpm/redhat/find-requires.ksyms
%define __find_provides /usr/lib/rpm/redhat/find-provides.ksyms %{kmod_name} %{?epoch:%{epoch}:}%{version}-%{release}
%define sbindir %( if [ -d "/sbin" -a \! -h "/sbin" ]; then echo "/sbin"; else echo %{_sbindir}; fi )
%define dup_state_dir %{_localstatedir}/lib/rpm-state/kmod-dups
%define kver_state_dir %{dup_state_dir}/kver
%define kver_state_file %{kver_state_dir}/%{kmod_kernel_version}.%(arch)
%define dup_module_list %{dup_state_dir}/rpm-kmod-%{kmod_name}-modules


Name:		kmod-ciq-ice+%{kmod_kernel_version}
Version:	%{kmod_driver_version}
Release:	%{kmod_rpm_release}%{?dist}
%if "%{kmod_driver_epoch}" != ""
Epoch:		%{kmod_driver_epoch}
%endif
Summary:	Ice kernel module for Rocky Linux and related EL systems
Group:		System/Kernel
License:	GPLv2
URL:		https://www.kernel.org/
BuildRoot:	%{_tmppath}/%{kmod_name}-%{version}-root



%global debug_package %{nil}
# macros for finding system files to update at install time (pci.ids, pcitable)
%define find() %(for f in %*; do if [ -e $f ]; then echo $f; break; fi; done)
%define _pciids   /usr/share/pci.ids        /usr/share/hwdata/pci.ids
%define _pcitable /usr/share/kudzu/pcitable /usr/share/hwdata/pcitable /dev/null
%define pciids    %find %{_pciids}
%define pcitable  %find %{_pcitable}



BuildRequires:	%kernel_devel_pkg = %kmod_kernel_version
%if "%{kmod_dist_build_deps}" != ""
BuildRequires:	%{kmod_dist_build_deps}
%endif

BuildRequires: kernel-core = %kmod_kernel_version
BuildRequires: kernel-headers = %kmod_kernel_version
BuildRequires: hwdata
BuildRequires: gcc

ExclusiveArch:	x86_64

%global kernel_source() /usr/src/kernels/%{kmod_kernel_version}.$(arch)

%global _use_internal_dependency_generator 0
%if "%{?kmod_kernel_version_min}" != ""
Provides:	%kernel_modules_pkg >= %{kmod_kernel_version_min}.%{_target_cpu}
%else
Provides:	%kernel_modules_pkg = %{kmod_kernel_version_dep}.%{_target_cpu}
%endif
Provides:	kmod-%{kmod_name}+%{kmod_kernel_version} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires(post):	%{sbindir}/weak-modules
Requires(postun):	%{sbindir}/weak-modules


Requires:	kernel = %{kmod_kernel_version}

Requires: findutils, gawk, bash, hwdata




%if "%{kmod_build_dependencies}" != ""
BuildRequires:  %{kmod_build_dependencies}
%endif
%if "%{kmod_dependencies}" != ""
Requires:       %{kmod_dependencies}
%endif
# if there are multiple kmods for the same driver from different vendors,
# they should conflict with each other.
Conflicts:	kmod-%{kmod_name}

%description
CIQ kmod package for Intel(R) Ethernet Connection E800 Series Linux Driver.

This is Intel driver version %{kmod_driver_version} , and it works with Rocky kernel %{kmod_kernel_version}


%prep

echo "BUILDROOT == %{buildroot}"
echo "SETUP == %{setup}"

%setup -n %{kmod_name}-%{version}





%build
export BUILD_KERNEL="%{kmod_kernel_version}.x86_64"

make -C src clean
make -C src


%install
export BUILD_KERNEL="%{kmod_kernel_version}.x86_64"

make -C src INSTALL_MOD_PATH=%{buildroot} MANDIR=%{_mandir} modules_install mandocs_install
# Remove modules files that we do not want to include
find %{buildroot}/lib/modules/ -name 'modules.*' -exec rm -f {} \;
cd %{buildroot}
find lib -name "ice.ko" -printf "/%p\n" \
  >%{_builddir}/%{kmod_name}-%{version}/file.list
find lib -name "auxiliary.ko" -printf "/%p\n" \
  >%{_builddir}/%{kmod_name}-%{version}/aux.list
find lib -path "*extern-symvers/auxiliary.symvers" -printf "/%p\n" \
  >>%{_builddir}/%{kmod_name}-%{version}/aux.list
find * -name "auxiliary_bus.h" -printf "/%p\n" \
  >>%{_builddir}/%{kmod_name}-%{version}/aux.list


mv %{buildroot}/lib/firmware/updates/intel/ice  %{buildroot}/lib/firmware/updates/intel/ice+%{kmod_kernel_version}
mv %{buildroot}/usr/share/man/man7/ice.7.gz   %{buildroot}/usr/share/man/man7/ice+%{kmod_kernel_version}.7.gz


# Place module in extra/ , and not in updates/ .  This is the only reliable way to get weak-modules script to detect it during kernel upgrades
# We want the same module to be usable across multiple compatible RHEL/Rocky kernels
mkdir -p %{buildroot}/lib/modules/%{kmod_kernel_version}.x86_64/extra/intel
mv %{buildroot}/lib/modules/%{kmod_kernel_version}.x86_64/updates/drivers/net/ethernet/intel/ice/ice.ko %{buildroot}/lib/modules/%{kmod_kernel_version}.x86_64/extra/intel/ice.ko


mkdir -p %{buildroot}/etc/depmod.d/

install -m 0644 %{SOURCE1} %{buildroot}/etc/depmod.d/


%clean
rm -rf %{buildroot}



%files
%dir /lib/firmware/updates/intel/ice+%{kmod_kernel_version}
%dir /lib/firmware/updates/intel/ice+%{kmod_kernel_version}/ddp/
%dir /lib/modules/%{kmod_kernel_version}.x86_64/extra/intel

/lib/modules/%{kmod_kernel_version}.x86_64/extra/intel/ice.ko
/lib/firmware/updates/intel/ice+%{kmod_kernel_version}/ddp/ice-1.3.30.0.pkg
/lib/firmware/updates/intel/ice+%{kmod_kernel_version}/ddp/ice.pkg
/lib/firmware/updates/intel/ice+%{kmod_kernel_version}/ddp/LICENSE

/etc/depmod.d/kmod-ciq-ice.conf

%defattr(-,root,root)
%{_mandir}/man7/ice+%{kmod_kernel_version}.7.gz
%doc COPYING
%doc README
%doc file.list
%doc pci.updates





%post

# CIQ kmod specific:  Symlink default firmware and manpage against this latest installed package
rm -f %{_mandir}/man7/ice.7.gz
ln -s %{_mandir}/man7/ice+%{kmod_kernel_version}.7.gz  %{_mandir}/man7/ice.7.gz

rm -rf /lib/firmware/updates/intel/ice
ln -s  /lib/firmware/updates/intel/ice+%{kmod_kernel_version}  /lib/firmware/updates/intel/ice
# (End CIQ specific section)


# Rest of post-setup script goes here:
if [ -d /usr/local/share/%{name} ]; then
	rm -rf /usr/local/share/%{name}
fi
mkdir /usr/local/share/%{name}
cp --parents %{pciids} /usr/local/share/%{name}/
echo "original pci.ids saved in /usr/local/share/%{name}";
if [ "%{pcitable}" != "/dev/null" ]; then
	cp --parents %{pcitable} /usr/local/share/%{name}/
	echo "original pcitable saved in /usr/local/share/%{name}";
fi

LD="%{_docdir}/%{name}";
if [ -d %{_docdir}/%{name}-%{version} ]; then
	LD="%{_docdir}/%{name}-%{version}";
fi

#Yes, this really needs bash
bash -s %{pciids} \
	%{pcitable} \
	$LD/pci.updates \
	$LD/pci.ids.new \
	$LD/pcitable.new \
	%{name} \
<<"END"
#! /bin/bash
# Copyright (C) 2017 Intel Corporation
# For licensing information, see the file 'LICENSE' in the root folder
# $1 = system pci.ids file to update
# $2 = system pcitable file to update
# $3 = file with new entries in pci.ids file format
# $4 = pci.ids output file
# $5 = pcitable output file
# $6 = driver name for use in pcitable file

exec 3<$1
exec 4<$2
exec 5<$3
exec 6>$4
exec 7>$5
driver=$6
IFS=

# pattern matching strings
ID="[[:xdigit:]][[:xdigit:]][[:xdigit:]][[:xdigit:]]"
VEN="${ID}*"
DEV="	${ID}*"
SUB="		${ID}*"
TABLE_DEV="0x${ID}	0x${ID}	\"*"
TABLE_SUB="0x${ID}	0x${ID}	0x${ID}	0x${ID}	\"*"

line=
table_line=
ids_in=
table_in=
vendor=
device=
ids_device=
table_device=
subven=
ids_subven=
table_subven=
subdev=
ids_subdev=
table_subdev=
ven_str=
dev_str=
sub_str=

# force a sub-shell to fork with a new stdin
# this is needed if the shell is reading these instructions from stdin
while true
do
	# get the first line of each data file to jump start things
	exec 0<&3
	read -r ids_in
	if [ "$2" != "/dev/null" ];then
	exec 0<&4
	read -r table_in
	fi

	# outer loop reads lines from the updates file
	exec 0<&5
	while read -r line
	do
		# vendor entry
		if [[ $line == $VEN ]]
		then
			vendor=0x${line:0:4}
			ven_str=${line#${line:0:6}}
			# add entry to pci.ids
			exec 0<&3
			exec 1>&6
			while [[ $ids_in != $VEN ||
				 0x${ids_in:0:4} < $vendor ]]
			do
				echo "$ids_in"
				read -r ids_in
			done
			echo "$line"
			if [[ 0x${ids_in:0:4} == $vendor ]]
			then
				read -r ids_in
			fi

		# device entry
		elif [[ $line == $DEV ]]
		then
			device=`echo ${line:1:4} | tr "[:upper:]" "[:lower:]"`
			table_device=0x${line:1:4}
			dev_str=${line#${line:0:7}}
			ids_device=`echo ${ids_in:1:4} | tr "[:upper:]" "[:lower:]"`
			table_line="$vendor	$table_device	\"$driver\"	\"$ven_str|$dev_str\""
			# add entry to pci.ids
			exec 0<&3
			exec 1>&6
			while [[ $ids_in != $DEV ||
				 $ids_device < $device ]]
			do
				if [[ $ids_in == $VEN ]]
				then
					break
				fi
				if [[ $ids_device != ${ids_in:1:4} ]]
				then
					echo "${ids_in:0:1}$ids_device${ids_in#${ids_in:0:5}}"
				else
					echo "$ids_in"
				fi
				read -r ids_in
				ids_device=`echo ${ids_in:1:4} | tr "[:upper:]" "[:lower:]"`
			done
			if [[ $device != ${line:1:4} ]]
			then
				echo "${line:0:1}$device${line#${line:0:5}}"
			else
				echo "$line"
			fi
			if [[ $ids_device == $device ]]
			then
				read -r ids_in
			fi
			# add entry to pcitable
			if [ "$2" != "/dev/null" ];then
			exec 0<&4
			exec 1>&7
			while [[ $table_in != $TABLE_DEV ||
				 ${table_in:0:6} < $vendor ||
				 ( ${table_in:0:6} == $vendor &&
				   ${table_in:7:6} < $table_device ) ]]
			do
				echo "$table_in"
				read -r table_in
			done
			echo "$table_line"
			if [[ ${table_in:0:6} == $vendor &&
			      ${table_in:7:6} == $table_device ]]
			then
				read -r table_in
			fi
			fi
		# subsystem entry
		elif [[ $line == $SUB ]]
		then
			subven=`echo ${line:2:4} | tr "[:upper:]" "[:lower:]"`
			subdev=`echo ${line:7:4} | tr "[:upper:]" "[:lower:]"`
			table_subven=0x${line:2:4}
			table_subdev=0x${line:7:4}
			sub_str=${line#${line:0:13}}
			ids_subven=`echo ${ids_in:2:4} | tr "[:upper:]" "[:lower:]"`
			ids_subdev=`echo ${ids_in:7:4} | tr "[:upper:]" "[:lower:]"`
			table_line="$vendor	$table_device	$table_subven	$table_subdev	\"$driver\"	\"$ven_str|$sub_str\""
			# add entry to pci.ids
			exec 0<&3
			exec 1>&6
			while [[ $ids_in != $SUB ||
				 $ids_subven < $subven ||
				 ( $ids_subven == $subven && 
				   $ids_subdev < $subdev ) ]]
			do
				if [[ $ids_in == $VEN ||
				      $ids_in == $DEV ]]
				then
					break
				fi
				if [[ ! (${ids_in:2:4} == "1014" &&
					 ${ids_in:7:4} == "052C") ]]
				then
					if [[ $ids_subven != ${ids_in:2:4} || $ids_subdev != ${ids_in:7:4} ]]
					then
						echo "${ids_in:0:2}$ids_subven $ids_subdev${ids_in#${ids_in:0:11}}"
					else
						echo "$ids_in"
					fi
				fi
				read -r ids_in
				ids_subven=`echo ${ids_in:2:4} | tr "[:upper:]" "[:lower:]"`
				ids_subdev=`echo ${ids_in:7:4} | tr "[:upper:]" "[:lower:]"`
			done
			if [[ $subven != ${line:2:4} || $subdev != ${line:7:4} ]]
			then
				echo "${line:0:2}$subven $subdev${line#${line:0:11}}"
			else
				echo "$line"
			fi
			if [[ $ids_subven == $subven  &&
			      $ids_subdev == $subdev ]]
			then
				read -r ids_in
			fi
			# add entry to pcitable
			if [ "$2" != "/dev/null" ];then
			exec 0<&4
			exec 1>&7
			while [[ $table_in != $TABLE_SUB ||
				 ${table_in:14:6} < $table_subven ||
				 ( ${table_in:14:6} == $table_subven &&
				   ${table_in:21:6} < $table_subdev ) ]]
			do
				if [[ $table_in == $TABLE_DEV ]]
				then
					break
				fi
				if [[ ! (${table_in:14:6} == "0x1014" &&
					 ${table_in:21:6} == "0x052C") ]]
				then
					echo "$table_in"
				fi
				read -r table_in
			done
			echo "$table_line"
			if [[ ${table_in:14:6} == $table_subven &&
			      ${table_in:21:6} == $table_subdev ]]
			then
				read -r table_in
			fi
			fi
		fi

		exec 0<&5
	done

	# print the remainder of the original files
	exec 0<&3
	exec 1>&6
	echo "$ids_in"
	while read -r ids_in
	do
		echo "$ids_in"
	done

	if [ "$2" != "/dev/null" ];then
	exec 0>&4
	exec 1>&7
	echo "$table_in"
	while read -r table_in
	do
		echo "$table_in"
	done
	fi

	break
done <&5

exec 3<&-
exec 4<&-
exec 5<&-
exec 6>&-
exec 7>&-

END

mv -f $LD/pci.ids.new  %{pciids}
if [ "%{pcitable}" != "/dev/null" ]; then
	mv -f $LD/pcitable.new %{pcitable}
fi

uname -r | grep BOOT || /sbin/depmod -a > /dev/null 2>&1 || true

if which dracut >/dev/null 2>&1; then
	echo "Updating initramfs with dracut..."
	if dracut --force ; then
		echo "Successfully updated initramfs."
	else
		echo "Failed to update initramfs."
		echo "You must update your initramfs image for changes to take place."
		exit -1
	fi
elif which mkinitrd >/dev/null 2>&1; then
	echo "Updating initrd with mkinitrd..."
	if mkinitrd; then
		echo "Successfully updated initrd."
	else
		echo "Failed to update initrd."
		echo "You must update your initrd image for changes to take place."
		exit -1
	fi
else
	echo "Unable to determine utility to update initrd image."
	echo "You must update your initrd manually for changes to take place."
	exit -1
fi


# Add this module to weak-updates/ across installed kernels
# We want it to be available to any compatible RHEL kernel, not just this one
modules=( $(find /lib/modules/%{kmod_kernel_version}.x86_64/extra/intel/ | grep 'ice\.ko$') )
printf '%s\n' "${modules[@]}" | %{_sbindir}/weak-modules --verbose --add-modules --no-initramfs



%preun
# remove firmware symlink
rm -rf /lib/firmware/updates/intel/ice

# remove manpage symlink
unlink %{_mandir}/man7/ice.7.gz



%postun
# If we delete this kmod, we need to remove other kernels' weak-updates
echo "/lib/modules/%{kmod_kernel_version}.x86_64/extra/intel/ice.ko" | %{_sbindir}/weak-modules --verbose --remove-modules --no-initramfs




%changelog
* Thu Oct 13 2022 Skip Grube <sgrube@ciq.co> 1.9.11
- Updated upstream module version to latest 1.9.11
- Fixed missing gcc buildroot issue
- Removed patch for Rocky 8.6: officially supported upstream now
- Added weak-modules/weak-updates support:  Same module should be usable across RHEL kernels
- Added depmod.d/ entry for weak-updates

* Wed Jul 6 2022 Skip Grube <sgrube@ciq.co> 1.8.9-1
- Packaging ICE kernel module for use in Rocky 8.6
- Initial version, based on old RH kmod spec and newer Intel sources
